// Codeblock frs TimeSlice freigeben
STATIC bIdleFunc

/* ... GET THE SYS ...
   ...
   ... */


// ---- Routine zum Time-Slice freigeben: ---

FUNCTION DosIdle()
RETURN .T.


// ---- Ermitteln, welcher Multitasker benutzt wird

INIT PROCEDURE whatsystem()
  DO CASE
  CASE DvActive()                                // DesqView
    bIdleFunc := {|| DvIdle()}
  CASE WinActive()                               // MS Windows
    bIdleFunc := {|| WinIdle()}
  CASE O_DosVer() >= 2000                        // OS/2 2.0
    bIdleFunc := {|| WinIdle()}
  OTHERWISE                                      // MS-DOS
    bIdleFunc := {|| DosIdle()}
  ENDCASE
return



// ---- Der eigentliche Ersatz fr inkey()

FUNCTION Wait4Key (nDelay)

  LOCAL nTaste := 0
  static endzeit

  IF nDelay == NIL
    // nTaste := Inkey()
    nDelay := .1
  ELSE
    endzeit := seconds()+nDelay
    DO WHILE nTaste == 0 .AND. ((nDelay == 0) .OR. (seconds() < endzeit))
      Eval(bIdleFunc)                            // ein Stck vom Kuchen abgeben...
      nTaste := Inkey()
    ENDDO
  ENDIF

RETURN(nTaste)

