.286
.MODEL LARGE,SYSCALL

INCLUDE CLIPPER.INC

DVACTIVE  PROTO
DVIDLE    PROTO
WINACTIVE PROTO
WINIDLE   PROTO
O_DOSVER  PROTO

.DATA

.CODE

DVACTIVE proc USES BP
        mov     cx,4445h
        mov     dx,5351h
        mov     ax,2b01h
        int     21h
        cmp     al,0ffh
        je      no_dv
        mov     ax,bx
        jmp     short got_dv
no_dv:  xor     ax,ax
got_dv: INVOKE  __RETL,ax
        ret
DVACTIVE endp



DVIDLE  proc USES BP
        mov     ax,101ah
        int     15h
        mov     ax,1000h
        int     15h
        mov     ax,1025h
        int     15h
        ret
DVIDLE  endp



WINACTIVE PROC USES BP ES
        mov     ax,352Fh                ; We are about to clobber them
        int     21h                     ; DOS get vector for 2Fh
        mov     ax,es                   ; ES:BX = vector
        or      ax,bx                   ; So let's see if there is one
        jz      got_windows             ; Nope, so return the zero
; Int 2f will work. So let's do it.
        mov     ax, 1600h               ; test for Windows
        int     2fh                     ; Go do the test
        and     ax, 007fh               ; Mask off bit so 80 is same as 0
; Result is now zero if not windows and nonzero if windows. Good enough.
got_windows:
        INVOKE  __RETL,ax
        ret
winactive endp



WINIDLE proc USES BP
        mov     ax,1680h
        int     2fh
        ret
WINIDLE endp

O_DOSVER PROC
        MOV     AH,30H
        INT     21H     ; AL bergeordnete, AH untergeordnete Ver-Nummer
        MOV     BL,AH   ; untergeordnete Nummer wegschreiben
        XOR     BH,BH
        mov     cl,100
        MUL     cl      ; bergeordnete * 100 -> AX
        ADD     AX,BX   ; + untergeordnete
        INVOKE  __RETNI,AX
        ret
O_DOSVER ENDP
END
